﻿
set nocount on
declare @comp_id uniqueidentifier ='%0'
declare @workspaces uniqueidentifier 
declare @system_object uniqueidentifier 
declare @guard_logic uniqueidentifier
declare @root_config_rights uniqueidentifier
declare @departments uniqueidentifier
declare @department uniqueidentifier
declare @user uniqueidentifier
declare @cars uniqueidentifier
declare @companies uniqueidentifier
declare @positions uniqueidentifier
declare @access_levels uniqueidentifier;
declare @service_reports uniqueidentifier;
begin transaction
declare @error_code int = 0
-----system_device----------
set @system_object = newid()
exec create_root_obj  'system_device', 'Системное устройство', @comp_id, @system_object
if @@error <> 0
	set @error_code = -1
-----system_device----------

-----guarded_objects----------
set @guard_logic = newid()
exec create_root_obj  'guard_logic','Объект охраны',@comp_id, @guard_logic
if @@error <> 0
	set @error_code = -1
-----guarded_objects----------	


-----workspaces----------
set @workspaces = newid()
exec create_root_obj 'workspaces','Рабочие места',@comp_id,@workspaces
if @@error <> 0
	set @error_code = -1
 -----workspaces----------															
											
-----root_config_rights----------
set @root_config_rights = newid()
exec create_root_obj 'root_config_rights','Корневой объект полномочий оператора',@comp_id,@root_config_rights	
if @@error <> 0
	set @error_code = -1	
-----root_config_rights----------	

-----создание  отделы----------
set @departments = newid()
exec "create_root_obj" 'departments','Отделы',@comp_id,@departments		
if @@error <> 0
	set @error_code = -1
-----создание  отделы----------	
--- создание отдела пцо----------
set @department = newid()
exec "create_obj" 'department',@department ,'администраторы пцо',@comp_id,'departments',@departments,@departments		
if @@error <> 0
	set @error_code = -1
--- создание отдела пцо----------
--- создание сотрудника иванов иван иванович------------
set @user = newid()
exec create_obj 'user',@user,'Иванов Иван Иванович',@comp_id,'department',@department,@departments
if @@error <> 0
	set @error_code = -1
update [t_user] set "surname" = 'Иванов', "user_name" ='Иван', "patronymic" ='Иванович',"tab_number" = '0001', "admin" = 1
where "id" = @user	
if @@error <> 0
	set @error_code = -1
insert into [user_rights] (	rights_id, user_id, password, user_type)
values ('{ffffffff-ffff-ffff-ffff-ffffffffffff}',@user , 'e10adc3949ba59abbe56e057f20f883e', 'user')
if @@error <> 0
	set @error_code = -1
--- создание сотрудника иванов иван иванович------------	


--- создание автомобилей----------
set @cars = newid()
exec "create_root_obj" 'cars','Автомобили',@comp_id,@cars		
if @@error <> 0
	set @error_code = -1
--- создание автомобилей----------

--- создание Организаций----------
set @companies = newid()
exec "create_root_obj" 'companies','Организации',@comp_id,@companies		
if @@error <> 0
	set @error_code = -1
--- создание Организаций----------

--- создание должностей----------
set @positions = newid()
exec "create_root_obj" 'positions','Должности',@comp_id,@positions		
if @@error <> 0
	set @error_code = -1
--- создание должностей----------

--- создание уровней доступа----------
set @access_levels = newid()
exec "create_root_obj" 'access_levels','Уровни доступа',@comp_id,@access_levels		
if @@error <> 0
	set @error_code = -1
--- создание уровней доступа----------

--- создание сервиса отчетов----------
set @service_reports = newid()
exec "create_root_obj"   'service_reports', 'Служба отчетов', @comp_id, service_reports;	
if @@error <> 0
	set @error_code = -1
	--- создание сервиса отчетов----------

if @error_code = 0
begin
	commit transaction
	insert into "computer" ("id", "name") values (@comp_id, '%1')
	if @@error <> 0
		set @error_code = -1
	if exists (select "version" from "config") 	
		update "config" set "system_type" ='%2'	
	else
		insert into "config" ("system_type", "version" ) values ('%2',1)				
end
else
begin
	rollback transaction
	raiserror (70010, 17 , 1 )
end		
