﻿do $$
declare _comp_id uuid ='%0';
declare _workspaces uuid ;
declare _system_object uuid ;
declare _guard_logic uuid;
declare _all_zones uuid ;
declare _all_logic_zones  uuid;
declare _all_logic_group_zones uuid;
declare _all_orion_zones uuid;
declare _all_orion_group_zones uuid;
declare _all_group_zones uuid;
declare root_user_authority uuid;
declare _departments uuid;
declare _department uuid;
declare _user uuid = '%1';
declare _user_pass_hash varchar(64) = '%2';
declare _cars uuid;
declare _companies uuid;
declare _positions uuid;
--declare _access_levels uuid;
--declare _access_areas uuid;

--declare _time_windows uuid;
declare _infrastructure uuid;
declare _filters uuid ;
declare _all_access_points  uuid;
declare _all_plans  uuid;
declare _images uuid;
declare _reports_web uuid;
declare _name varchar(150);
begin
	-----system_device----------
	select COALESCE (name, 'Системное устройство') into _name from types where "type" = 'system_device';
	_system_object := uuid_generate_v4();
	call "create_root_obj"( 'system_device',_name,_comp_id,_system_object);
	-----system_device----------
	
	-----guarded_objects----------
	select COALESCE (name, 'Объект охраны') into _name from types where "type" = 'guard_logic';
	_guard_logic := uuid_generate_v4();
	call "create_root_obj"( 'guard_logic',_name,_comp_id,_guard_logic);
	insert into t_guard_logic_incidents_actions("id", "description", "incident_types", "action_id")
	VALUES (_guard_logic, 'Передана заявка инженерам', '[1,5]', uuid_generate_v4()),
			(_guard_logic, 'Передан сигнал в ЕДДС и штаб ГО и ЧС', '[0,1,2]', uuid_generate_v4()),
			(_guard_logic, 'Принят сигнал пожарной тревоги или пуска пожаротушения', '[0,1,2]', uuid_generate_v4()),
			(_guard_logic, 'Сигнал охранной тревоги принят', '[3,4]', uuid_generate_v4()),
			(_guard_logic, 'Осуществлен вызов пожарной бригады на объект', '[0,1,2]', uuid_generate_v4()),
			(_guard_logic, 'Передана заявка в обслуживающую организацию', '[1,5]', uuid_generate_v4()),
			(_guard_logic, 'На объект вызвана группа быстрого реагирования', '[3,4]', uuid_generate_v4()),
			(_guard_logic, 'Сигнал передан в ЕДДС и отделение полиции', '[3,4]', uuid_generate_v4());	
	-----guarded_objects----------	
		
	-----guarded_objects----------
	select COALESCE (name, 'Фильтры') into _name from types where "type" = 'filters';
	_filters := uuid_generate_v4();
	call "create_obj"( 'filters',_filters ,_name,_comp_id,'guard_logic',_guard_logic,_guard_logic);	
	-----guarded_objects----------
	
	-----all_access_points----------
	select COALESCE (name, 'Точки прохода') into _name from types where "type" = 'all_access_points';
	_all_access_points := uuid_generate_v4();
	call "create_obj"( 'all_access_points', _all_access_points , _name, _comp_id, 'filters', _filters, _guard_logic);		
	-----all_access_points----------	
	
	-----all_zones----------
	select COALESCE (name, 'Все зоны‹') into _name from types where "type" = 'all_zones';
	_all_zones := uuid_generate_v4();
	call "create_obj"( 'all_zones',_all_zones ,_name,_comp_id,'filters', _filters ,_guard_logic);	
	-----all_zones----------	
	
	-----all_logic_zones----------
	select COALESCE (name, 'Системные зоны') into _name from types where "type" = 'all_logic_zones';
	_all_logic_zones := uuid_generate_v4();
	call "create_obj"( 'all_logic_zones',_all_logic_zones ,_name,_comp_id,'filters', _filters,_guard_logic);	
	-----all_logic_zones----------
	
	-----all_logic_group_zones----------
	select COALESCE (name, 'Системные группы зон') into _name from types where "type" = 'all_logic_group_zones';
	_all_logic_group_zones := uuid_generate_v4();
	call "create_obj"( 'all_logic_group_zones',_all_logic_group_zones ,_name,_comp_id,'filters', _filters,_guard_logic);	
	-----all_logic_group_zones----------
	
	-----all_orion_zones----------
	select COALESCE (name, 'Аппартаные зоны') into _name from types where "type" = 'all_orion_zones';
	_all_orion_zones := uuid_generate_v4();
	call "create_obj"( 'all_orion_zones',_all_orion_zones ,_name,_comp_id,'filters', _filters,_guard_logic);	
	-----all_zones----------
	
	-----all_group_zones----------
	select COALESCE (name, 'Все группы зон') into _name from types where "type" = 'all_group_zones';
	_all_group_zones := uuid_generate_v4();
	call "create_obj"( 'all_group_zones',_all_group_zones ,_name,_comp_id,'filters', _filters,_guard_logic);	
	-----all_group_zones----------
	
	-----all_orion_group_zones----------
	select COALESCE (name, 'Аппаратные группы зон') into _name from types where "type" = 'all_orion_group_zones';
	_all_orion_group_zones := uuid_generate_v4();
	call "create_obj"( 'all_orion_group_zones',_all_orion_group_zones ,_name,_comp_id,'filters', _filters, _guard_logic);	
	-----all_zones----------	
	
	-----images-------------------------
	select COALESCE (name, 'Изображения') into _name from types where "type" = 'images';
	_images := uuid_generate_v4();
	call "create_obj"( 'images',_images ,_name,_comp_id,'guard_logic',_guard_logic,_guard_logic);	
	-----images-------------------------
	
	-----all_plans----------
	select COALESCE (name, 'Планы') into _name from types where "type" = 'all_plans';
	_all_plans := uuid_generate_v4();
	call "create_obj"( 'all_plans',_all_plans ,_name,_comp_id,'filters', _filters,_guard_logic);	
	-----all_plans----------
	
	----infrastructure-------------------
	select COALESCE (name, 'Структура') into _name from types where "type" = 'infrastructure';
	_infrastructure:= uuid_generate_v4();
	call "create_obj"( 'infrastructure',_infrastructure ,_name,_comp_id,'guard_logic',_guard_logic,_guard_logic);	
	----infrastructure-------------------
	
	-----workspaces----------
	select COALESCE (name, 'Рабочие места') into _name from types where "type" = 'workspaces';
	_workspaces := uuid_generate_v4();
	call "create_root_obj"( 'workspaces', _name,_comp_id,_workspaces);	
	 -----workspaces----------															
												
	-----root_config_rights----------
	select COALESCE (name, 'Полномочия персонала') into _name from types where "type" = 'root_user_authority';
	root_user_authority := uuid_generate_v4();
	call "create_root_obj"( 'root_user_authority',_name,_comp_id,root_user_authority);
	-----root_config_rights----------	
	
	-----создание  отделы----------
	select COALESCE (name, 'Отделы') into _name from types where "type" = 'departments';
	_departments := uuid_generate_v4();
	call "create_root_obj"( 'departments',_name,_comp_id,_departments);		
	-----создание  отделы----------	
	--- создание отдела пцо----------
	--select COALESCE (name, 'Администраторы') into _name from types where "type" = 'department';
	_department := uuid_generate_v4();
	call "create_obj"( 'department',_department, 'Администраторы' ,_comp_id,'departments',_departments,_departments);		
	--- создание отдела пцо----------
	--- создание сотрудника иванов иван иванович------------
	call "create_obj"( 'user', _user, 'Иванов Иван Иванович',_comp_id,'department',_department,_departments);
	update "t_user" set "surname" = 'Иванов', "user_name" ='Иван', "patronymic" ='Иванович', "tab_number" = '0001', "admin" = 1, "date_birth" = ( current_date - interval'23 year'), 
	"date_issue_docs" = current_date - interval '1 day',"date_expiration_docs" = ( current_date + interval'10 year'), sex = 1
	where "id" = _user;	
	insert into public.user_rights(	rights_id, user_id, password, user_type)
	values ('{ffffffff-ffff-ffff-ffff-ffffffffffff}',_user , _user_pass_hash, 'user');
	--- создание сотрудника иванов иван иванович------------	
	
	--- создание автомобилей----------
	select COALESCE (name, 'Автомобили') into _name from types where "type" = 'cars';
	_cars := uuid_generate_v4();
	call "create_root_obj"( 'cars',_name,_comp_id,_cars);	
	--- создание автомобилей----------
	
	--- создание Организаций----------
	select COALESCE (name, 'Организации') into _name from types where "type" = 'companies';
	_companies := uuid_generate_v4();
	call "create_root_obj"( 'companies',_name,_comp_id,_companies);	
	--- создание Организаций----------
	
	--- создание должностей----------
	select COALESCE (name, 'Должности') into _name from types where "type" = 'positions';
	_positions := uuid_generate_v4();
	call "create_root_obj"( 'positions',_name,_comp_id,_positions);	
	--- создание должностей----------
	
	--- создание уровней доступа----------
	/*select COALESCE (name, 'Уровни доступа') into _name from types where "type" = 'access_levels';
	_access_levels := uuid_generate_v4();
	call "create_root_obj"( 'access_levels',_name,_comp_id,_access_levels);*/
	--- создание уровней доступа----------
	
	--- создание зона доступа----------
	/*select COALESCE (name, 'Зоны доступа') into _name from types where "type" = 'access_areas';
	_access_areas := uuid_generate_v4();
	call "create_root_obj"( 'access_areas',_name,_comp_id,_access_areas);*/
	--- создание зона доступа----------

	--- создание окон времени----------
	/*select COALESCE (name, 'Окна времени') into _name from types where "type" = 'time_windows';
	_time_windows := uuid_generate_v4();
	call "create_root_obj"( 'time_windows', _name, _comp_id, _time_windows);*/
	--- создание окон времени----------
	
	
	-----reports_web----------
	--_reports_web := uuid_generate_v4();
	--call "create_root_obj"( 'reports_web','WEB отчеты',_comp_id,_reports_web);
	-----reports_web----------
	
	insert into "computer" ("id", "name") values (_comp_id, '%3');
	
	if exists (select "version" from "config") then
		update "config" set "system_type" = '%4';
	else
		insert into "config" ("system_type", "version") values ('%4', 2);
	end if;	
end;
$$