create function [dbo].[filllinks](@type nvarchar(250),@id uniqueidentifier, @tmp  loctypetable readonly)
	returns  @tt table 
		(
		id uniqueidentifier,
		type nvarchar(250), 
		name nvarchar(250)
		)
	as
	begin
		
		declare @mtemp loctypetable
		
		insert into @mtemp select * from @tmp
		
		insert into @mtemp select  * from fillparant(@type,@id, @mtemp) m where m.id not in ( select t.id from  @mtemp t)
		
		declare curtable cursor local fast_forward for  
		(select linking_obj_type,linking_obj_id  
			   from [links] where linked_obj_id = @id and linked_obj_type = @type and [dbo].[links].parent = 0
			   and linking_obj_type not in 
				( select [prototypes].type from [prototypes] where [prototypes].[prototype] = 'loop_guarded' or
				[prototypes].[prototype] = 'loop_partition' or [prototypes].[type] = 'accesspoint' and linking_obj_type not in ('flat', 'object')) 
		)
		
		declare @temptype nvarchar(250) 
		declare @tempid uniqueidentifier    
		
		open curtable
		
		fetch next from curtable into @temptype, @tempid
		while @@fetch_status = 0
		begin
			insert into @mtemp select  * from fillparant(@temptype,@tempid, @mtemp) m where m.id not in ( select t.id from  @mtemp t)
			fetch next from curtable into @temptype, @tempid
		end		
			
			
		insert into @tt  select distinct  * from @mtemp
		return 
	end
go
	create function [dbo].[getxmlvaluebynumberparam](@inumberparam int, @text nvarchar(max))
	returns nvarchar(max)
	as
	begin
		declare @xml xml
		set @xml = @text
		return (select nref.value('@value', 'nvarchar(max)') 
				from   @xml.nodes('//msgparameters/parameter') as r(nref) 
				where  nref.value('@index', 'int' ) = @inumberparam)
		
	end 
go
	create function [dbo].[fillparant](@type nvarchar(250),@id uniqueidentifier, @tmp  loctypetable readonly)
	returns @tt table 
		(
		id uniqueidentifier,
		type nvarchar(250), 
		name nvarchar(250)
		)
	as
	begin
		declare @temprecord loctypetable
		declare @idparent uniqueidentifier 	
		insert into @temprecord select  * from @tmp
		declare @idchild uniqueidentifier = @id
		declare @tempparenttype nvarchar(250) = @type
		declare @existparent bit  = 0
		
		if not exists ( select * from @temprecord m where m.id = @idchild)
		begin			  				
			
			insert into @temprecord (id,name,type ) values 
				(@idchild,
				(select top 1 objects .name from objects where objects.id = @idchild ),
				@tempparenttype) 
			insert into @temprecord select  * from filllinks(@tempparenttype,@idchild, @temprecord) m where m.id not in ( select t.id from  @temprecord t)	
		end
				
		while (@tempparenttype <> '' and @existparent = 0)
		begin
			select top 1 @tempparenttype = [dbo].[links].linking_obj_type, @idparent = [dbo].[links].linking_obj_id  
			   from [dbo].[links] where [dbo].[links].linked_obj_id = @idchild and [dbo].[links].parent = 1  
			if @@rowcount = 0
				set @tempparenttype = ''
			else 
			begin
				set @idchild = @idparent				
				if not exists ( select * from @temprecord m where m.id = @idchild)
				begin			  				
					
					insert into @temprecord (id,name,type ) values 
						(@idchild,
						(select top 1 objects .name from objects where objects.id = @idchild ),
						@tempparenttype) 
					insert into @temprecord select  * from filllinks(@tempparenttype,@idchild, @temprecord) m where m.id not in ( select t.id from  @temprecord t)	
				end
				else
					set @existparent = 1
			end
		end	
		insert into @tt select distinct * from 	@temprecord	
		return
	end
go
	create function  [dbo].[fngetcompnamebytype](@id uniqueidentifier, @type nvarchar (150))
	returns uniqueidentifier
	as
	begin
	declare @comp_id uniqueidentifier
	declare @child_type nvarchar(150) = @type
	declare @child_id uniqueidentifier = @id
	declare @parent_type nvarchar(150) = @child_type
	declare @parent_id uniqueidentifier = @child_id
	while  not exists (select * from [root_links] where (id = @parent_id))
	begin
	select @parent_type = [links].linking_obj_type, @parent_id = [links].linking_obj_id
	from [links] where [links].linked_obj_id = @child_id and [links].linked_obj_type = @child_type and [links].parent=1
	if @@rowcount > 0
	begin 
	set @child_type = @parent_type
	set @child_id =  @parent_id
	end
	else
	return @comp_id
	end
	select @comp_id = [root_links].comp_id from [root_links] where [root_links].id = @parent_id
	return @comp_id
	end
	
go

create procedure create_root_obj(@type nvarchar(150), @name nvarchar(150),@comp_id uniqueidentifier, @id uniqueidentifier, @add_state int = 1)
as 
begin
	set nocount on
	declare @maxcount int = 0
	declare @rowcount int = 0
	if exists (select [linked_obj_type] from [possible_links] where 
		(lower("linked_obj_type") = lower(@type) and "parent" = 1)) 		
	begin
		raiserror (70010, 17 , 1 )
	end	

	select  @maxcount = [types].[max_count] from [types]  where lower([types].[type]) = lower(@type)
	set @rowcount = (select count(*)  from [root_links], [objects]
	where [root_links].[id] = [objects].[id] and [root_links].[comp_id] = @comp_id and [objects].[type] = @type)
	if (@maxcount <> -1 and @rowcount >=@maxcount)
	begin
		raiserror (70015, 17 , 1 )
		return
	end
	begin transaction
	declare @error_code int = 0
	declare @dt datetime2 = getutcdate()
	declare  @script nvarchar (max) = 'insert into [t_'+@type+'] ([id]) values('''+convert(nvarchar(50), @id)+''')'
	exec (@script)
	if @@error <> 0
		set @error_code = -1
	insert into [objects] ([id], [type], [name], [time]) values(@id, @type, @name, @dt)
	if @@error <> 0
		set @error_code = -1
	insert into [root_links] ([id], [comp_id], [root_id]) values (@id, @comp_id, @id)
	if @@error <> 0
		set @error_code = -1
		
	if (@add_state == 1)
	begin
		insert into [object_states] ([id], [state], [data], [time])
			values (@id, convert(varbinary(64), 0xffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff), '', @dt)
		if @@error <> 0
			set @error_code = -1
	end		
	if @error_code = 0
	begin
		commit transaction
	end
	else
	begin
		rollback transaction
		raiserror (70010, 17 , 1 )
		return
	end

end

go 

create procedure create_obj(@obj_type nvarchar(150),@obj_id uniqueidentifier, @name_obj nvarchar(150),
	@comp_id uniqueidentifier, @parent_type nvarchar(150), @parent_id uniqueidentifier, 
	@root_id uniqueidentifier, @ins_type_table int = 1, @add_state int = 1)
as 
begin
	set nocount on
	declare @maxcount int = 0
	declare @rowcount int = 0
	declare @maxchildcount int = 0

	select  @maxchildcount = [types].[max_children_count] from [types]  where lower([types].[type]) = lower(@parent_type)
	set @rowcount = (select count(*)  from [links] where  [links].[linking_obj_type] = lower(@parent_type) and [links].[linking_obj_id] = @parent_id
		and [links].parent = 1)
	if (@maxchildcount <> -1 and @rowcount >=@maxchildcount)
	begin
		raiserror (70014, 17 , 1 )
		return
	end

	select  @maxcount = [types].[max_count] from [types]  where lower([types].[type]) = lower(@obj_type)
	set @rowcount = (select count(*) from [links] where  [links].[linking_obj_type] = lower(@parent_type) and [links].[linking_obj_id] =  @parent_id
		and [links].[linked_obj_type] = lower(@obj_type) and [links].parent = 1)
	if (@maxcount <> -1 and @rowcount >=@maxcount)
	begin
		raiserror (70015, 17 , 1 )
		return
	end
	select top 1 @comp_id = [comp_id] from [root_links] where [id] = @parent_id
	begin transaction
	
	declare @error_code int = 0
	declare @dt datetime2 = getutcdate()

	declare  @script nvarchar (max) = 'insert into [t_'+@obj_type+'] ([id]) values('''+convert(nvarchar(50), @obj_id)+''')'
	if (@ins_type_table == 1)
	begin
		exec (@script)
		if @@error <> 0
			set @error_code = -1
	end
	
	insert into [objects] ([id], [type], [name], [time]) values(@obj_id, @obj_type,@name_obj, @dt)
	if @@error <> 0
		set @error_code = -1
	insert into [links] ([linked_obj_id], [linked_obj_type], [linking_obj_id], [linking_obj_type], [parent], [data], [time])
		values (@obj_id, lower(@obj_type), @parent_id,lower(@parent_type), 1, 0, @dt)
	if @@error <> 0
		set @error_code = -1
	insert into [root_links] ([id], [comp_id], [root_id]) values (@obj_id, @comp_id, @root_id)
	if @@error <> 0
		set @error_code = -1
	if (@add_state == 1)
	begin
		insert into [object_states] ([id], [state], [data], [time])
		values (@obj_id, convert(varbinary(64), 0xffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff), '', @dt)
		if @@error <> 0
			set @error_code = -1
	end
	if @error_code = 0
	begin
		commit transaction
	end
	else
	begin
		rollback transaction
		raiserror (70010, 17 , 1 )
		return
	end

end