if exists(select * from  sys.triggers tr
		inner join  sys.objects obj on (tr.parent_id = obj.object_id)
		where obj.name = 'links' and tr.name = 'deletelink')
	begin
		drop trigger deletelink
	end 
go 	
	create trigger [dbo].[deletelink] on [dbo].[links]
		for delete
		as
		set nocount on	
		insert into [delete_links]  ([linking_obj_type], [linking_obj_id], [linked_obj_type], [linked_obj_id],
			[parent],[data], [time])			
			select m.[linking_obj_type], m.[linking_obj_id], m.[linked_obj_type], m.[linked_obj_id],m.[parent],m.[data],getutcdate() 	
				from deleted m
			left join [delete_links] as f on m.[linking_obj_id] = f.[linking_obj_id] 
				and m.[linked_obj_id] = f.[linked_obj_id]
			where f.[linked_obj_type] is null
		update [delete_links] 
	set [delete_links].[time] = getutcdate()
	from [delete_links] 
		right join deleted m on  m.[linking_obj_id] = [delete_links] .[linking_obj_id] 
				and [delete_links] .[linked_obj_id] = m.[linked_obj_id]
		where  [delete_links] .[linked_obj_type] is not null
