/*
 create table hot_keys
*/
create table if not exists hot_keys(
		module_name varchar(255) not null,
		key_word varchar(50) not null,
		description varchar(255) null,
		keys varchar(255) null
	) ;	
/*
 finished create table hot_keys
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------	
/*
 create table config
*/
create table if not exists config(
		history_base varchar(255) null,
		version int null, 
		system_type varchar(255) null,
		auto_login_user_type varchar(255) null,
		auto_login_user_id uuid null, 
		note varchar(255) null
	); 
/*
 finished create table config
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------	
/*
 create table gbrtrack
*/
create table if not exists gbrtrack(
		id uuid not null,
		dtime timestamp not null,
		speed_east float null,
		speed_north float null,
		speed_upward float null,
		latitude float not null,
		longitude float not null,
		altitude float not null
	);
/*
 finished create table gbrtrack
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------	
/*
 create table [system_scheme]
*/
create table if not exists system_scheme(
			linking_comp_name varchar(150) not null,
			linked_comp_name varchar(150) not null
		) ;
/*
 finished create table [system_scheme]
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table user_rights
*/
create table if not exists user_rights(		
		rights_id uuid not null,
		user_id uuid not null,
		password varchar not null,
		user_type varchar(150) null
	);

/*
 finished create table user_rights
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table message_groups
*/
create table if not exists message_groups(		
		number int not null,
		name varchar null,
		description varchar null,		
		color int null,
		font_color int null
	);
/*
 finished create table message_groups
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table rights
*/
create table if not exists rights(
		rights_id uuid not null,
		name varchar(150) not null,
		permissions varchar not null
	);
/*
 finished create table rights
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table rights_arms
*/
create table if not exists rights_arms(
		id uuid not null,
		arm_type varchar(150) not null,
		arm_id uuid not null
	);
/*
 finished create table rights_arms
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table prototypes
*/
create table if not exists prototypes(
		type varchar(150) not null,
		prototype varchar  not null
	);
/*
 finished create table prototypes
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table delete_links
*/
create table if not exists delete_links(
		linking_obj_type varchar(150) not null,
		linking_obj_id uuid not null,
		linked_obj_type varchar(150) not null,
		linked_obj_id uuid not null,
		parent int not null,
		data varchar null,
		time timestamp not null
	);
/*
 finished create table delete_links
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table links
*/
create table if not exists links(
		linking_obj_type varchar(150) not null,
		linking_obj_id uuid not null,
		linked_obj_type varchar(150) not null,
		linked_obj_id uuid not null,
		parent int not null,
		data varchar null,
		time timestamp not null		
	); 						  
create unique index if not exists idx_links on links(parent asc,linking_obj_id asc,
			linked_obj_id asc	);
/*
 finished create table links
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table possible_links
*/
create table if not exists possible_links(
		linking_obj_type varchar(150) not null,
		linked_obj_type varchar(150) not null,
		parent int not null,
		count int null
	);
/*
 finished create table possible_links
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table [dictionary]
*/
create table if not exists dictionary(
	type varchar(150) not null,
	name varchar(150) not null,
	number int not null,
	text varchar null
	);
/*
 finished create table [dictionary]
*/
/*
 create table state_transitions
*/
create table if not exists state_transitions(
	type varchar(150) not null,
	state int null,
	action int not null,
	new_state int not null,
	state_group int null,
	private int null
	);
/*
 finished create table state_transitions
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table object_states
*/
create table if not exists object_states(
	id uuid not null,	
	data varchar null,
	time timestamp not null,
	state bytea null,
	state_private bytea null,
	constraint  unq_object_states unique (id ) 
	);
/*
 finished create table object_states
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table link_chain_data
*/
create table if not exists link_chain_data(
		id uuid not null,
		data varchar null,
		time timestamp not null,
		constraint  unq_link_chain_data unique ( id )
	);
/*
 finished create link_chain_data
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table link_chains
*/
create table if not exists link_chains(
		obj_type varchar(150) not null,
		obj_id  uuid not null,
		id uuid not null,
		chain_type varchar(150) not null,
		time timestamp not null
	);
/*
 finished create link_chains
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table possible_link_chains
*/
create table if not exists possible_link_chains(
		chain_type  varchar(150) not null,
		type varchar(150) not null
	);
/*
 finished create possible_link_chains
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table state_groups
*/
create table if not exists state_groups(
	number int not null,
	type varchar(150) not null,
	name varchar null,
	priority int null,
	private int null,
	constraint unq_states_groups unique ("number", "type", "private")	
	);
/*
 finished create table state_groups
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table objects
*/
create table if not exists objects(
	 id uuid not null,
	 type varchar(150) not null,
	 name varchar(150) not null,
	 time timestamp not null,
	 constraint unq_objects unique	(id ,	type)
	);
/*
 finished create table objects
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table root_links
*/
create table if not exists root_links(
		id uuid not null,
		comp_id uuid not null,
		root_id uuid not null,
	 constraint unq_root_links unique (id, comp_id )	
	);
/*
 finished create table root_links
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table delete_objects
*/
create table if not exists delete_objects(
		id uuid not null,
		params varchar null,
		name varchar null,
		time timestamp not null,
		root_id uuid not null,
		comp_id uuid not null,
		type varchar(150) not null,
	 constraint unq_delete_objects unique(id)	
	) ;
/*
 finished create table delete_objects
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table messages
*/
create table if not exists messages(
	type varchar(150) not null,
	type_message int not null,
	"number" int not null,
	log int not null,
	description varchar(512) not null,
	font_color int null,
	color int null,
	message_group int null,
	db_log int null,
	incident_type_number int null,
	constraint unq_messages unique	( type, "number")
	);
/*
 finished create table messages
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table events_protocol
*/

create table if not exists events_protocol(
	event_id uuid not null,
	status int null,
	type varchar(150) null,
	id uuid null,
	action int null,
	dtime timestamp null,
	params varchar null,
	user_type varchar(150) null,
	user_id uuid null,
	comp_id uuid null,
	msg_flags int null,
	comment varchar null,	
	constraint unq_events_protocol unique (event_id)
	);
/*
 finished create table events_protocol
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table states
*/
create table if not exists states(
	type varchar(150) not null,
	state int not null,
	priority int,
	image varchar(255) null,
	description varchar(255) null,
	state_group int not null,	
	fill_color int null,	
	fill_partial int null,
	font_color int null,	
	private int null,
	constraint unq_states unique (type, state, state_group,private)
	) ;
/*
 finished create table states
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table types
*/
create table if not exists types(
	 type varchar(150) not null,
	 name varchar(150) not null,
	 image varchar(255) not null,
	 module varchar(255) not null,
	 max_count int null,
	 max_children_count int null,
	 description varchar(512) null,
	 replicable int null,
	 memory int null,
	 meta varchar null,
	 "global" int null,
	 platform_type integer not null default 0,
	 states_mode integer not null default 0,
	 slave int null,
	 memory_states int null,
	 sort_priority integer not null default 2147483647,
	 constraint unq_types unique ( type),
	 constraint types_platform_type_check check (platform_type = any (array[0, 1, 2]))
	);
/*
 finished create table types
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table fields_description
*/
create table if not exists fields_description(
		type_name varchar(250) not null,
		field_name varchar(250) not null,
		description varchar not null
	);
/*
 finished create table fields_description
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table [dependent_tables]
*/
create table if not exists dependent_tables(
	add_params_name varchar(150) not null,
	type varchar(150) not null,
	param int not null		
	);
/*
 finished create table table_dependents
*/
----------------------------------------------------------------------------------------------------------
/*
 create table [report_dictionary]
*/
create table if not exists report_dictionary(
		type int not null,
		name varchar(50) not null,
		value varchar null
	);
/*
 finished create table report_dictionary
*/

----------------------------------------------------------------------------------------------------------
/*
 create table iconcolorstatus
*/
create table if not exists  iconcolorstatus(
		color_status bytea null
	) ;
/*
 finished create table iconcolorstatus
*/

----------------------------------------------------------------------------------------------------------
/*
 create table computer
*/
create table if not exists computer(
	id uuid not null,
	name varchar(150) not null,	
	ip varchar(150) null,	
	constraint unq_comps unique (id, name)
	) ;
/*
 finished create table comps
*/
----------------------------------------------------------------------------------------------------------
/*
 create table incidents
*/
create table if not exists incidents(
	id uuid not null,
    type varchar(150) not null,
	state bytea null,
	data varchar null,
    "time" timestamp  not null,
	user_type  varchar(150) not null,
	user_id  uuid not null,
	"create_time" timestamp not null,
	constraint unq_incidents unique ( id)
	) ;
/*
 finished create incidents
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table incident_types
*/
create table if not exists incident_types(
    type varchar(150) not null,
    name varchar(150) null,
    description varchar(512) null,
	number int not null,
	constraint unq_incident_types unique ( type),
	constraint unq_incident_types_number unique ( number)
	) ;
/*
 finished create incident_types
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table incident_object_links
*/
create table if not exists incident_object_links(
    id uuid not null,
    obj_type varchar(150) not null,
	obj_id uuid not null,
	data varchar null,
	"time" timestamp  not null
	) ;
/*
 finished create incident_object_links
*/
----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
/*
 create table incident_message_links
*/
create table if not exists incident_message_links(
    id uuid not null,
	msg_id  uuid not null, 
	data varchar null,
	"time" timestamp  not null
	) ;
/*
 finished create incident_message_links
*/
----------------------------------------------------------------------------------------------------------
/*
 create table computer
*/
create table if not exists computer(
	id uuid not null,
	name varchar(150) not null,	
	ip varchar(150) null,	
	constraint unq_comps unique (id, name)
	) ;
/*
 finished create table comps
*/
----------------------------------------------------------------------------------------------------------
/*
 create table computer
*/
create table if not exists computer(
	id uuid not null,
	name varchar(150) not null,	
	ip varchar(150) null,	
	constraint unq_comps unique (id, name)
	) ;
/*
 finished create table comps
*/
----------------------------------------------------------------------------------------------------------
/*
 create table computer
*/
create table if not exists computer(
	id uuid not null,
	name varchar(150) not null,	
	ip varchar(150) null,	
	constraint unq_comps unique (id, name)
	) ;
/*
 finished create table comps
*/
----------------------------------------------------------------------------------------------------------