do $$
declare
  _row  RECORD;
  _row2  RECORD;
begin
	for _row in  select dependent_tables."type", inf.table_name, dependent_tables.add_params_name  from "dependent_tables" 
				inner join  "information_schema"."tables" as inf  on  inf.table_name = ('t_' || dependent_tables."type" ||'_' || dependent_tables.add_params_name) 
				where add_params_name = 'floors'
	loop
		if (_row."type" = 'access_point') 
		then
			execute  'INSERT INTO "links"(  linked_obj_type, linked_obj_id, linking_obj_type, linking_obj_id, parent, data, "time")
				select  ''' || _row."type" ||''', id, ''plan'', plan_id, 0,
					json_build_object( ''items'', json_agg (json_build_object(''x'',x,''y'',y,''group_idx'',group_idx, ''subgroup_idx'',subgroup_idx,''icon_idx'',icon_idx, ''angle'',angle )))::text,
					now() from "'|| _row."table_name"||'" as tab left join links on tab.id = links.linking_obj_id and tab.plan_id = links.linked_obj_id
					where links.parent is null group by id, plan_id';
		else
			execute  'INSERT INTO "links"( linked_obj_type, linked_obj_id, linking_obj_type, linking_obj_id, parent, data, "time")
				select ''' || _row."type" ||''', id, ''plan'', plan_id, 0,
					json_build_object( ''items'', json_agg (json_build_object(''x'',x,''y'',y,''group_idx'',group_idx, ''subgroup_idx'',subgroup_idx,''icon_idx'',icon_idx, ''angle'',angle,''indicator'', indicator )))::text,
					now() from "'|| _row."table_name"||'"as tab left join links on tab.id = links.linking_obj_id and tab.plan_id = links.linked_obj_id
					where links.parent is null group by id, plan_id';
		end if;
		delete from dependent_tables where dependent_tables."type" = _row."type" and dependent_tables.add_params_name = _row.add_params_name;
		execute  'DROP TABLE ' || _row."table_name" ;
	end loop;	

	for _row2 in select dependent_tables."type", inf.table_name, dependent_tables.add_params_name   from "dependent_tables" 
				inner join  "information_schema"."tables" as inf  on  inf.table_name = ('t_' || dependent_tables."type" ||'_' || dependent_tables.add_params_name) 
				inner join prototypes on dependent_tables."type" = prototypes.type
				where prototype = 'area_on_plan'	
	loop
	
		execute  'INSERT INTO "links"(  linked_obj_type, linked_obj_id,linking_obj_type, linking_obj_id, parent, data, "time")
				select  ''' || _row2."type" ||''', id, ''plan'', plan_id, 0,
					json_build_object( ''items'', json_agg (json_build_object(''area_type'',area_type,''angle'',angle, ''geometry'', (geometry::json->>''geometry'')::json)))::text,
					now() from "'|| _row2."table_name"||'" as tab left join links on tab.id = links.linking_obj_id and tab.plan_id = links.linked_obj_id
					where links.parent is null group by id, plan_id';
		delete from dependent_tables where dependent_tables."type" = _row2."type" and dependent_tables.add_params_name = _row2.add_params_name;
		execute  'DROP TABLE ' || _row2."table_name" ;
	end loop;	

	UPDATE config SET  version=2;
end;
$$