--declare @tablebase  table ( name nvarchar(max))
--insert into @tablebase select table_name from information_schema.tables 


----------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------	
/*
   hot_keys
*/
if exists (select * from information_schema.tables where table_name = 'hot_keys')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='hot_keys'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'module_name','nvarchar',255,'not null',1),
		('key_word', 'nvarchar',50, 'not null',1),
		('description','nvarchar',255,'null',1),
		('keys', 'nvarchar',255, 'null',1)  
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
	exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end
	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [hot_keys](
		[module_name] [nvarchar](255) not null,
		[key_word] [nvarchar](50) not null,
		[description] [nvarchar](255) null,
		[keys] [nvarchar](255) null
	) on [primary]
end

/*
    hot_keys
*/
----------------------------------------------------------------------------------------------------------
go 
----------------------------------------------------------------------------------------------------------	
/*
   config
*/
if exists (select * from information_schema.tables where table_name = 'config')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='config'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'history_base','nvarchar',255,'null',1),
		('version', 'int',null, 'null',0),
		( 'system_type','nvarchar',255,'null',1),
		( 'auto_login_user_type','nvarchar',255,'null',0),
		( 'auto_login_user_id','uniqueidentifier',null,'null',0),
		( 'note','nvarchar',null,'null',1)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
	exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end
	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [config](
		[history_base] [nvarchar](255) null,
		[version] [int] null, 
		[system_type] [nvarchar](255) null,
		[auto_login_user_id] [uniqueidentifier] null,
		[note] [nvarchar](max) null
	) on [primary]
end

/*
    config
*/
----------------------------------------------------------------------------------------------------------
go 
----------------------------------------------------------------------------------------------------------	
/*
   gbrtrack
*/
if exists (select * from information_schema.tables where table_name = 'gbrtrack')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='gbrtrack'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'id','uniqueidentifier',null,'not null',0),
			  ( 'dtime', 'datetime2',null, 'not null',0),
			  ( 'speed_east', 'float',null, 'null',0),
			  ( 'speed_north', 'float',null, 'null',0),
			  ( 'speed_upward', 'float',null, 'null',0),
			  ( 'latitude', 'float',null, 'not null',0),
			  ( 'longitude', 'float',null, 'not null',0),
			  ( 'altitude', 'float',null, 'not null',0)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
	exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end
	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [dbo].[gbrtrack](
		[id] [uniqueidentifier] not null,
		[dtime] [datetime2] not null,
		[speed_east] [float] null,
		[speed_north] [float] null,
		[speed_upward] [float] null,
		[latitude] [float] not null,
		[longitude] [float] not null,
		[altitude] [float] not null
	) on [primary]
end

/*
    gbrtrack
*/
----------------------------------------------------------------------------------------------------------
go 
----------------------------------------------------------------------------------------------------------	
/*
   [system_scheme]
*/
if exists (select * from information_schema.tables where table_name = 'system_scheme')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='system_scheme'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'linking_comp_name','nvarchar',150,'not null',1),
		('linked_comp_name', 'nvarchar',150, 'not null',1)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
	exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end
	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [system_scheme](
			[linking_comp_name] [nvarchar](150) not null,
			[linked_comp_name] [nvarchar](150) not null
		) on [primary]
end

/*
    [system_scheme]
*/
----------------------------------------------------------------------------------------------------------
go 
----------------------------------------------------------------------------------------------------------
/*
   user_rights
*/
if exists (select * from information_schema.tables where table_name = 'user_rights')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='user_rights'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'rights_id','uniqueidentifier',null,'not null',0),
		('user_id', 'uniqueidentifier',null, 'not null',0),
		('password','nvarchar',null,'null',1),
		('user_type', 'nvarchar',150, 'null',1) 

	set @script  = '' 
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [user_rights](		
		[rights_id] [uniqueidentifier] not null,
		[user_id] [uniqueidentifier] not null,
		[password] [nvarchar](max) not null,
		[user_type] [nvarchar](150) null
	) on [primary]
end

/*
    user_rights
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   message_groups
*/
if exists (select * from information_schema.tables where table_name = 'message_groups')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='message_groups'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'number','int',null,'null',0),
		('name', 'nvarchar',null, 'null',1),
		('description','nvarchar',null,'null',1),
		('color', 'int',null, 'null',0),
		('font_color', 'int',null, 'null',0)  
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [message_groups](		
		[number] [int]  not null,
		[name] [nvarchar](max) null,
		[description] [nvarchar](max) null,		
		[color] [int] null, 
		[font_color] [int] null
	) on [primary]
end
/*
    message_groups
*/
----------------------------------------------------------------------------------------------------------
go 
----------------------------------------------------------------------------------------------------------
/*
   rights
*/
if exists (select * from information_schema.tables where table_name = 'rights')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='rights'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'rights_id','uniqueidentifier',null,'not null',0),
		('name', 'nvarchar',150, 'not null',1),		
		('permissions', 'nvarchar',null, 'not null',1)
	select @script = coalesce(@script,'') +' drop trigger ' + tr.name from sys.triggers tr
		inner join  sys.objects obj on (tr.parent_id = obj.object_id)
		where obj.name = @tablename
	if @@rowcount > 0
	begin				
		exec (@script)
		if @@error > 0
			set @error = -1 
	end 
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [rights](
		[rights_id] [uniqueidentifier] not null,
		[name] [nvarchar](150) not null,		
		[permissions] [nvarchar](max) not null
	) on [primary]	
end

/*
    rights
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   rights_arms
*/
if exists (select * from information_schema.tables where table_name = 'rights_arms')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='rights_arms'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'id','uniqueidentifier',null,'not null',0),
		('arm_type', 'nvarchar',150, 'not null',1),
		('arm_id','uniqueidentifier',null,'not null',0) 
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [rights_arms](
		[id] [uniqueidentifier] not null,
		[arm_type] [nvarchar](150) not null,
		[arm_id] [uniqueidentifier] not null
	) on [primary]	
end

/*
    rights_arms
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   prototypes
*/
if exists (select * from information_schema.tables where table_name = 'prototypes')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 	
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='prototypes'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'type','nvarchar',150,'not null',1),		
		('prototype','nvarchar',null,'not null',1)  
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [prototypes](
		[type] [nvarchar](150) not null,
		[prototype] [nvarchar] (max) not null
	) on [primary]
end

/*
    prototypes
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   delete_links
*/
if exists (select * from information_schema.tables where table_name = 'delete_links')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 	
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='delete_links'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'linking_obj_type','nvarchar',150,'not null',1),
		('linking_obj_id', 'uniqueidentifier',null, 'not null',0),
		('linked_obj_type','nvarchar',150,'not null',1),
		('linked_obj_id', 'uniqueidentifier',null, 'not null',0),
		('parent', 'int',null, 'not null',0),
		('data', 'nvarchar',null, 'null',1),
		('time', 'datetime2',null, 'not null',0)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [delete_links](
		[linking_obj_type] [nvarchar](150) not null,
		[linking_obj_id] [uniqueidentifier] not null,
		[linked_obj_type] [nvarchar](150) not null,
		[linked_obj_id] [uniqueidentifier] not null,
		[parent] [int] not null,
		[data] [nvarchar](max) null,
		[time] [datetime2] not null,
	) on [primary]
end

/*
    delete_links
*/
----------------------------------------------------------------------------------------------------------
go

----------------------------------------------------------------------------------------------------------
/*
   links
*/
if exists (select * from information_schema.tables where table_name = 'links')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 	
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='links'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'linking_obj_type','nvarchar',150,'not null',1),
		('linking_obj_id', 'uniqueidentifier',null, 'not null',0),
		('linked_obj_type','nvarchar',150,'not null',1),
		('linked_obj_id', 'uniqueidentifier',null, 'not null',0),
		('parent', 'int',null, 'not null',0),
		('data', 'nvarchar',null, 'null',1),
		('time', 'datetime2',null, 'not null',0)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	select i.name from sysobjects o
	inner join sysindexes i on o.id = i.id
	where o.name= 'links' and o.xtype = 'u' and i.indid > 0 and indexproperty(i.id, i.name, 'isstatistics') = 0
	if @@rowcount = 0
	begin
		create nonclustered index [idx_links] on [dbo].[links]
		(
			[parent] asc,
			[linking_obj_id] asc,
			[linked_obj_id] asc
		)with (sort_in_tempdb = off, drop_existing = off, online = off) on [primary]
		if @@error > 0
				set @error = -1 
	end	
	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [links](
		[linking_obj_type] [nvarchar](150) not null,
		[linking_obj_id] [uniqueidentifier] not null,
		[linked_obj_type] [nvarchar](150) not null,
		[linked_obj_id] [uniqueidentifier] not null,
		[parent] [int] not null,
		[data] [nvarchar](max) null,
		[time] [datetime2] not null,		
	) on [primary]
	create nonclustered index [idx_links] on [dbo].[links]
		(
			[parent] asc,
			[linking_obj_id] asc,
			[linked_obj_id] asc
		)with (sort_in_tempdb = off, drop_existing = off, online = off) on [primary]
end

/*
    links
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   possible_links
*/
if exists (select * from information_schema.tables where table_name = 'possible_links')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='possible_links'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'linking_obj_type','nvarchar',150,'not null',1),
		('linked_obj_type', 'nvarchar',150, 'not null',1),
		('parent','int',null,'not null',0),
		('count','int',null,'null',0)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [possible_links](
		[linking_obj_type] [nvarchar](150) not null,
		[linked_obj_type] [nvarchar](150) not null,
		[parent] [int] not null,
		[count] [int] null
	) on [primary]	
end

/*
    possible_links
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   [dictionary]
*/
if exists (select * from information_schema.tables where table_name = 'dictionary')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='dictionary'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'type','nvarchar',150,'not null',1),
		('name', 'nvarchar',150, 'not null',1),
		('number', 'int',null, 'not null',0),
		('text','nvarchar',null,'null',1) 
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [dbo].[dictionary](
	[type] [nvarchar](150) not null,
	[name] [nvarchar](150) not null,
	[number] [int] not null,
	[text] [nvarchar](max) null
	) on [primary]	
end

/*
    [dictionary]
*/
----------------------------------------------------------------------------------------------------------
go

----------------------------------------------------------------------------------------------------------
/*
   state_transitions
*/
if exists (select * from information_schema.tables where table_name = 'state_transitions')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='state_transitions'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'type','nvarchar',150,'not null',1),
		('state', 'int',null, 'null',0),
		('action','int',null,'not null',0),
		('new_state', 'int',null, 'not null',0),	
		('state_group', 'int',null, 'null',0),
		('private', 'int',null, 'null',0)  		
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [dbo].[state_transitions](
	[type] [nvarchar](150) not null,
	[state] [int] null,
	[action] [int] not null,
	[new_state] [int] not null,
	[state_group] [int] null,
	[private] [int] null
	) on [primary]
end

/*
    state_transitions
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   object_states
*/
if exists (select * from information_schema.tables where table_name = 'object_states')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='object_states'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'id','uniqueidentifier',null,'not null',0),
		('data','nvarchar',null,'null',1),		
		('time', 'datetime2',null, 'not null',0),
		('state', 'varbinary',64, 'null',0),
		('state_private', 'varbinary',64, 'null',0)  		
	set @script  = ''
	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	alter table object_states add constraint pk_states primary key clustered
	([id] asc)
	with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)  
	on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [dbo].[object_states](
	[id] [uniqueidentifier] not null,	
	[data] [nvarchar](max) null,
	[time] [datetime2] not null,
	[state] [varbinary](64) null,
	[state_private] [varbinary](64) null,
	constraint [pk_states] primary key clustered 
	(
		[id] asc
		)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    object_states
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   state_groups
*/
if exists (select * from information_schema.tables where table_name = 'state_groups')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='state_groups'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'number','int',null,'not null',0),
		('type', 'nvarchar',150, 'not null',1),
		('name','nvarchar',null,'null',1),
		('priority', 'int',null, 'null',0),
		('private', 'int',null, 'null',0) 		
	set @script  = ''
	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	alter table state_groups add constraint pk_states_groups primary key clustered
	([number] asc,[type] asc, [private] asc)
	with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)  	
	on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [dbo].[state_groups](
	[number] [int] not null,
	[type] [nvarchar](150) not null,
	[name] [nvarchar](max) null,
	[priority] [int] null,
	[private] [int] null,
	constraint [pk_states_groups] primary key clustered 
	(
		[number] asc,
		[type] asc,
		[private] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    state_groups
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   objects
*/
if exists (select * from information_schema.tables where table_name = 'objects')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='objects'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'id','uniqueidentifier',null,'not null',0),
		('type', 'nvarchar',150, 'not null',1),
		('name','nvarchar',150,'not null',1),
		('time', 'datetime2',null, 'not null',0)
	
	select @script = coalesce(@script,'') +' drop trigger ' + tr.name from sys.triggers tr
		inner join  sys.objects obj on (tr.parent_id = obj.object_id)
		where obj.name = @tablename
	if @@rowcount > 0
	begin				
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	set @script  = ''
	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	alter table objects add constraint pk_objects_1 primary key clustered
	([id] asc,[type] asc)
	with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)  
	on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [objects](
		[id] [uniqueidentifier] not null,
		[type] [nvarchar](150) not null,
		[name] [nvarchar](150) not null,
		[time] [datetime2] not null,
	 constraint [pk_objects_1] primary key clustered 
	(
		[id] asc,
		[type] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    objects
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   root_links
*/
if exists (select * from information_schema.tables where table_name = 'root_links')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='root_links'
	delete from @fieldstable 
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'id','uniqueidentifier',null,'not null',0),
		('comp_id', 'uniqueidentifier',null, 'not null',0) ,
		( 'root_id','uniqueidentifier',null,'not null',0)
	set @script  = ''
	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end
	
	alter table root_links add constraint pk_root_links primary key clustered ( [id] asc,[comp_id] asc)
		with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) 
		on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [root_links](
		[id] [uniqueidentifier] not null,
		[comp_id] [uniqueidentifier] not null,
		[root_id] [uniqueidentifier] not null,
	 constraint [pk_root_links] primary key clustered 
	(
		[id] asc,
		[comp_id] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    root_links
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   link_chain_data
*/
if exists (select * from information_schema.tables where table_name = 'link_chain_data')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='link_chain_data'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'id','uniqueidentifier',null,'not null',0),
		('data ', 'nvarchar',null, 'null',1),
		('time', 'datetime2',null, 'not null',0)
	set @script  = ''
	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	alter table link_chain_data add constraint pk_link_chain_data primary key clustered
	([id] asc)
	with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)  
	on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [dbo].[link_chain_data](
		[id] [uniqueidentifier] not null,
		[data] [nvarchar](max) null,
		[time] [datetime2] not null,
	 constraint [pk_link_chain_data] primary key clustered 
	(
		[id] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    link_chain_data
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   link_chains
*/
if exists (select * from information_schema.tables where table_name = 'link_chains')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='link_chains'
	delete from @fieldstable 	  
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'obj_type','nvarchar',150,'not null',1),
		('obj_id','uniqueidentifier',null,'not null',0),
		('id','uniqueidentifier',null,'not null',0),
		( 'chain_type','nvarchar',150,'not null',1),
		('time', 'datetime2',null, 'not null',0)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [link_chains](
		[ obj_type ] [nvarchar](150) not null,		
		[ obj_id ] [uniqueidentifier] not null,
		[ id ] [uniqueidentifier] not null,
		[ chain_type ] [nvarchar](150) not null,	
		[ time ] [datetime2] not null
	) on [primary]	
end

/*
    link_chains
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   possible_link_chains
*/
if exists (select * from information_schema.tables where table_name = 'possible_link_chains')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='possible_link_chains'
	delete from @fieldstable 	  
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values		
		('chain_type','nvarchar',150,'not null',1),
		( 'type','nvarchar',150,'not null',1)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [possible_link_chains](			
		[ chain_type ] [nvarchar](150) not null,
		[ type ] [nvarchar](150) not null
	) on [primary]	
end

/*
    possible_link_chains
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   delete_objects
*/
if exists (select * from information_schema.tables where table_name = 'delete_objects')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='delete_objects'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'id','uniqueidentifier',null,'not null',0),
		('params', 'nvarchar',null, 'null',1),
		('name','nvarchar',null,'null',1),
		('time', 'datetime2',null, 'not null',0),
		('root_id','uniqueidentifier',null,'not null',0),
		('comp_id', 'uniqueidentifier',null, 'not null',0),
		('type', 'nvarchar',150, 'not null',1) 		
	set @script  = ''
	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	alter table delete_objects add constraint pk_delete_objects primary key clustered
	([id] asc)
	with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)  
	on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [dbo].[delete_objects](
		[id] [uniqueidentifier] not null,
		[params] [nvarchar](max) null,
		[name] [nvarchar](max) null,
		[time] [datetime2] not null,
		[root_id] [uniqueidentifier] not null,
		[comp_id] [uniqueidentifier] not null,
		[type] [nvarchar](150) not null,
	 constraint [pk_delete_objects] primary key clustered 
	(
		[id] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    delete_objects
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   messages
*/
if exists (select * from information_schema.tables where table_name = 'messages')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='messages'
	delete from @fieldstable 
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'type','nvarchar',150,'not null',1),
		('type_message', 'int',null, 'not null',0),
		( 'number','int',null,'not null',0),
		( 'log','int',null,'not null',0),
		( 'description','nvarchar',512,'not null',1),
		( 'font_color','int',null,'null',0),
		( 'color','int',null,'null',0), 
		( 'message_group','int',null,'null',0),
		( 'db_log','int',null,'null',0)
	set @script  = ''	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	
	alter table messages add constraint pk_messages primary key clustered ( [type] asc, [number] asc)
		with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) 
		on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [messages](
		[type] [nvarchar](150) not null,
		[type_message] [int] not null,
		[number] [int] not null,
		[log] [int] not null,
		[description] [nvarchar](512) not null,
		[font_color] [int] null,
		[color] [int] null,
		[message_group] [int] null,
		[db_log] [int] null
	 constraint [pk_messages] primary key clustered 
	(
		[type] asc,
		[number] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    messages
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   events_protocol
*/
if exists (select * from information_schema.tables where table_name = 'events_protocol')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='events_protocol'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'event_id','uniqueidentifier',null,'not null',0),
		('status', 'int',null, 'null',0),
		( 'type','nvarchar',150,'null',1),
		('id', 'uniqueidentifier',null, 'null',0),
		( 'action','int',null,'null',0),
		('dtime', 'datetime2',null, 'null',0),
		( 'params','nvarchar',null,'null',1),
		( 'user_type','nvarchar',150,'null',0),
		('user_id', 'uniqueidentifier',null, 'null',0),
		( 'msg_flags','int',null,'null',0),
		('comp_id','uniqueidentifier',null,'null',0),
		( 'comment','nvarchar',null,'null',1),		
	set @script  = ''
	
	select @script = coalesce(@script,'') +' drop trigger ' + tr.name from sys.triggers tr
		inner join  sys.objects obj on (tr.parent_id = obj.object_id)
		where obj.name = @tablename
	if @@rowcount > 0
	begin				
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	set @script  = ''
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	alter table events_protocol add constraint pk_events_protocol primary key clustered
	([event_id] asc)
	with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)  
	on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [dbo].[events_protocol](
	[event_id] [uniqueidentifier] not null,
	[status] [int] null,
	[type] [nvarchar](150) null,
	[id] [uniqueidentifier] null,
	[action] [int] null,
	[dtime] [datetime2] null,
	[params] [nvarchar](max) null,
	[user_id] [uniqueidentifier] null,
	[msg_flags] [int] null,
	[comp_id] [uniqueidentifier] null,
	[comment] [nvarchar](max) null,
	 constraint [pk_events_protocol] primary key nonclustered 
	(
		[event_id] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    events_protocol
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   states
*/
if exists (select * from information_schema.tables where table_name = 'states')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='states'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'type','nvarchar',150,'not null',1),
		('state', 'int',null, 'not null',0),
		('priority', 'int',null, 'null',0),
		('image','nvarchar',255,'null',1),
		( 'description','nvarchar',255,'null',1),
		( 'state_group','int',null,'not null',0),		
		('fill_color','int',null,'null',0),
		('fill_partial', 'int',null, 'null',0),
		('font_color', 'int',null, 'null',0),
		('private', 'int',null, 'null',0),
	set @script  = ''
	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	alter table [states] add constraint [pk_states1] primary key clustered
	([type] asc,[state] asc,[state_group] asc, [private] asc)
	with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)  
	on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [dbo].[states](
	[type] [nvarchar](150) not null,
	[state] [int] not null,
	[priority] [int] null,
	[image] [nvarchar](255) null,
	[description] [nvarchar](255) null,
	[state_group] [int] not null,	
	[fill_color] [int] null,
	[font_color] [int] null,	
	[fill_partial] [int] null,
	[private] [int] null,
	 constraint [pk_states1] primary key clustered 
	(
		[type] asc,
		[state] asc,
		[private] asc,
		[state_group] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    states
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   types
*/
if exists (select * from information_schema.tables where table_name = 'types')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='types'
	delete from @fieldstable 
	  
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'type','nvarchar',150,'not null',1),
		('name', 'nvarchar',150, 'not null',1),
		('image','nvarchar',255,'not null',1),
		('module', 'nvarchar',255, 'not null',1),
		( 'max_count','int',null,'null',0),
		('max_children_count', 'int',null, 'null',0),
		('description','nvarchar',512,'null',1),
		( 'replicable','int',null,'null',0),
		('memory', 'int',null, 'null',0),
		('meta', 'nvarchar',null, 'null',1),		
		('platform_type', 'int',null, 'not null',0),
		('slave', 'int',null, 'null',0),
		('has_states ', 'int',null, 'null',0)
		('states_mode ', 'int',null, 'null',0)
		('global ', 'int',null, 'null',0)
	set @script  = ''
	
	select distinct @script = coalesce(@script,'') + ' alter table '+ @tablename +' drop constraint '+
		constraint_name  --+
		--'with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)' 
		from information_schema.key_column_usage
		where table_name = @tablename
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name 		
	from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end		
	set @icount =  1	
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	alter table [types] add constraint [pk_types] primary key clustered
	([type] asc)
	with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on)  
	on [primary]
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
	
end
else
begin
	create table [types](
		[type] [nvarchar](150) not null,
		[name] [nvarchar](150) not null,
		[image] [nvarchar](255) not null,
		[module] [nvarchar](255) not null,
		[max_count] [int] null,
		[max_children_count] [int] null,
		[description] [nvarchar](512) null,
		[replicable] [int] null,
		[memory] [int] null,
		[meta] [nvarchar] (max) null,
		[platform_type] [int] not null  DEFAULT (0),
		[states_mode] [int] null  DEFAULT (0),
		[slave] [int] null,
		[memory_states] [int] null,
		[global] [int] null,
	 constraint [types_platform_type_check] check (platform_type in (0, 1, 2)),
	 constraint [pk_types] primary key clustered 
	(
		[type] asc
	)with (pad_index  = off, statistics_norecompute  = off, ignore_dup_key = off, allow_row_locks  = on, allow_page_locks  = on) on [primary]
	) on [primary]
end

/*
    types
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   fields_description
*/
if exists (select * from information_schema.tables where table_name = 'fields_description')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='fields_description'
	delete from @fieldstable 	  
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'type_name','nvarchar',150,'not null',1),
		('field_name', 'nvarchar',150, 'not null',1),
		('description','nvarchar',null,'not null',1) 
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [fields_description](
		[type_name] [nvarchar](250) not null,
		[field_name] [nvarchar](250) not null,
		[description] [nvarchar](max) not null
	) on [primary]	
end

/*
    fields_description
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   [dependent_tables]
*/
if exists (select * from information_schema.tables where table_name = 'dependent_tables')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='dependent_tables'
	delete from @fieldstable 	  
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'param', 'int',null, 'not null',0),
		('add_params_name', 'nvarchar',150, 'not null',1),
		('type','nvarchar',150,'not null',1) 
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+	
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin						
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''		
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [dependent_tables](
		[add_params_name] [nvarchar](150) not null,
		[type] [nvarchar](150) not null,
		[param] [int] not null		
	) on [primary]
end
/*
    table_dependents
*/


go
----------------------------------------------------------------------------------------------------------
/*
   [report_dictionary]
*/
if exists (select * from information_schema.tables where table_name = 'report_dictionary')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='report_dictionary'
	delete from @fieldstable 	  
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values( 'type', 'int',null, 'not null',0),
		('name', 'nvarchar',50, 'not null',1),
		('value','nvarchar',null,'not null',1) 
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+	
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin						
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''		
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end
	
	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [report_dictionary](
		[type] [int] not null,
		[name] [nvarchar](50) not null,
		[value] [nvarchar](max) null
	) on [primary]
end
/*
    report_dictionary
*/
go
----------------------------------------------------------------------------------------------------------
/*
   iconcolorstatus
*/
if exists (select * from information_schema.tables where table_name = 'iconcolorstatus')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='iconcolorstatus'
	delete from @fieldstable 	  
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values ('color_status', 'varbinary',null, 'null',0) 	
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [iconcolorstatus](
		[color_status] [varbinary](max)null
	) on [primary]	
end

/*
    iconcolorstatus
*/
----------------------------------------------------------------------------------------------------------
go
----------------------------------------------------------------------------------------------------------
/*
   computer
*/
if exists (select * from information_schema.tables where table_name = 'computer')
begin
	declare @fieldstable table ([name] [nvarchar](max) not null,
	[type] [nvarchar](max) not null,
	[size] [int] null,
	[emty] [nvarchar](8) not null,
	[isstring] bit null)
		
		
	declare @script nvarchar(max) = ''
	declare @error int = 0;	
	declare @tablename nvarchar(max) =''	
	declare @parmdefinition nvarchar(1000)  = N'@result int output'
	declare @icount int 
	begin transaction
		-- 
	set @script = ''
	set @error = 0
	set @tablename ='computer'
	delete from @fieldstable 	  
	
	insert into @fieldstable  (name,type, size,emty, isstring)
		values  	
		( 'id','uniqueidentifier',null,'not null',0),
		('ip', 'nvarchar',null, 'null',1),
		('name', 'nvarchar',null, 'not null',1)
	set @script  = ''
	select @script = coalesce(@script,'') + ' alter table '+ @tablename + ' drop column '+
		information_schema.columns.column_name from information_schema.columns  	
	where information_schema.columns.column_name not in (select t.name from @fieldstable t)
	and   information_schema.columns.table_name =@tablename  
	if @@rowcount > 0
	begin
		exec (@script)
		if @@error > 0
			set @error = -1 
	end	
	set @icount =  1
	set @script ='select @result = count(*) from ' + @tablename
	
	--   
		exec sp_executesql @script,  @parmdefinition, @result = @icount output
	if  @icount > 0 
	begin
		set @script  = ''
		select 
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') 
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ') 
			end	
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  
		and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			@script = 
		    case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ')
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
				t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max) ')
			end					
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)	and  t.emty = 'null' 
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
	end
	else
	begin
	    --        not null
		set @script  = ''
		select 
		
			@script = 
			case when t.isstring = 0 then
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,' ') + ' ' + t.emty+ ' '  
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' add '+
				t.name + ' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' from @fieldstable m where m.name = t.name) ,'(max)') + ' ' + t.emty+ ' '  
			end
		from @fieldstable t  	
		where  t.name not in (select  information_schema.columns.column_name from information_schema.columns where information_schema.columns.table_name = @tablename)  	
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 
		set @script  = ''
		select 
			 @script = 
			case when t.isstring = 0	 then			
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,' ')	
			else
				coalesce(@script,'') + ' alter table '+ @tablename + ' alter column '+
			t.name +' '+ t.type+ coalesce((select ' ('+ convert(nvarchar(50),m.size)  + ') ' + ' ' + t.emty+ ' ' from @fieldstable m where m.name = t.name) ,'(max) ')	
			end	
		from information_schema.columns 
		inner join @fieldstable t on (t.name = information_schema.columns.column_name and  information_schema.columns.table_name = @tablename) 
		where  coalesce(information_schema.columns.data_type,'') != coalesce(t.type,'') or coalesce(information_schema.columns.character_maximum_length,-1) != coalesce(t.size,-1)
		or (information_schema.columns.is_nullable  = 'yes' and t.emty = 'not null' )
		or (information_schema.columns.is_nullable  = 'no' and t.emty = 'null' )
		if @@rowcount > 0
		begin
			exec (@script)
			if @@error > 0
				set @error = -1 
		end 	
	end

	if @error = 0
		commit transaction
	else
		rollback transaction
end
else
begin
	create table [computer](
		[id] [uniqueidentifier] not null,
		[ip] [nvarchar](max) null,
		[name] [nvarchar](max) not null,
	constraint [pk_computer] primary key clustered 
	(
	[id] asc
	)with (pad_index = off, statistics_norecompute = off, ignore_dup_key = off, allow_row_locks = on, allow_page_locks = on) on [primary]	
	) on [primary]
end

/*
    iconcolorstatus
*/
----------------------------------------------------------------------------------------------------------
